/*
* This file is part of Code::Blocks Studio, an open-source cross-platform IDE
* Copyright (C) 2003  Yiannis An. Mandravellos
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* Contact e-mail: Yiannis An. Mandravellos <mandrav@codeblocks.org>
* Program URL   : http://www.codeblocks.org
*
* $Revision: 2073 $
* $Id: messagelog.cpp 2073 2006-02-24 21:50:38Z killerbot $
* $HeadURL: svn://svn.berlios.de/codeblocks/trunk/src/sdk/messagelog.cpp $
*/

#include "sdk_precomp.h"

#ifndef CB_PRECOMP
    #include "messagelog.h" // class's header file
    #include "manager.h"
    #include "messagemanager.h"
	#include "configmanager.h"

    #include <wx/intl.h>
#endif

// class constructor
MessageLog::MessageLog()
    : wxPanel(Manager::Get()->GetAppWindow(), wxID_ANY, wxDefaultPosition, wxDefaultSize)
{
    m_PageId = -1;
}

// class destructor
MessageLog::~MessageLog()
{
}

wxFont MessageLog::GetDefaultLogFont(bool fixedPitchFont)
{
    int size = Manager::Get()->GetConfigManager(_T("message_manager"))->ReadInt(_T("/log_font_size"), 8);
    wxFont font(size,
                fixedPitchFont ? wxFONTFAMILY_MODERN : wxFONTFAMILY_DEFAULT,
                wxFONTSTYLE_NORMAL,
                wxFONTWEIGHT_NORMAL);
    return font;
}
